import 'package:pubspec_manager/pubspec_manager.dart';
import 'package:test/test.dart';

void main() {
  test('pub spec ...', () async {
    PubSpec(
      name: 'new eric',
    )
      ..version.set('1.0.0-alpha.2')
      ..description.set('An example')
      ..environment
          .set(sdk: '>3.0.0 <=4.0.0', flutter: '1.0.0')
          .comments
          .append('Its a flutter app')
      ..homepage
          .set('https://onepub.dev/home')
          .comments
          .append('The home page')
          .append('more')
      ..publishTo
          .set('https://onepub.dev/xxxxyyy')
          .comments
          .append('Publish to a private repo.')
          .append('more')
      ..repository
          .set('https://onepub.dev/Issues')
          .comments
          .append('The code is here')
      ..issueTracker
          .set('https://onepub.dev/Issues')
          .comments
          .append('Log bugs here')
      ..documentation
          .set('https://onepub.dev')
          .comments
          .append('This is the doco')
      ..dependencies
          .append(DependencyAltHostedBuilder(
            name: 'dcli',
            hosted: 'https://onepub.dev',
            comments: const ['DCLI to do file system stuff', 'Hello world'],
          ))
          .append(
              DependencyPubHostedBuilder(name: 'dcli_core', version: '1.0.0'))
      ..devDependencies
          .append(
            DependencyPubHostedBuilder(
                comments: const ['hi there', 'ho there'],
                name: 'test',
                version: '1.0.0'),
          )
          .append(DependencyPubHostedBuilder(
            name: 'test_it',
            version: '1.0.0',
          ))
      ..dependencyOverrides.append(DependencyPathBuilder(
        name: 'dcli',
        path: '../../some/path',
        comments: const ['For local dev'],
      ))
      ..platforms
          .append(PlatformEnum.ios)
          .append(PlatformEnum.android)
          .append(PlatformEnum.web)
      ..executables
          .append(name: 'myapp')
          .append(name: 'installer', script: 'install')
          .comments.append('')
      ..save(filename: 'example.yaml');
  });
}
